org.openstreetmap.josm.plugins.streetside.gui.imageinfo

## Class ThreeSixtyDegreeViewerPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javafx.embed.swing.JFXPanel
        - - org.openstreetmap.josm.plugins.streetside.gui.imageinfo.ThreeSixtyDegreeViewerPanel

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable

      public class ThreeSixtyDegreeViewerPanel
      extends javafx.embed.swing.JFXPanel

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static javafx.scene.image.Image` | `back`
    `private static javafx.scene.PerspectiveCamera` | `camera`
    `private static double` | `cameraDistance`
    `private static CameraTransformer` | `cameraTransform`
    `private static CubemapBox` | `cubemapBox`
    `private static javafx.scene.Scene` | `cubemapScene`
    `private static javafx.scene.Scene` | `defaultScene`
    `private static javafx.scene.image.Image` | `down`
    `private static javafx.scene.image.Image` | `front`
    `private static javafx.scene.image.Image` | `left`
    `private static double` | `mouseDeltaX`
    `private static double` | `mouseDeltaY`
    `private static double` | `mouseOldX`
    `private static double` | `mouseOldY`
    `private static double` | `mousePosX`
    `private static double` | `mousePosY`
    `private static javafx.scene.image.Image` | `right`
    `private static javafx.scene.Group` | `root`
    `private static long` | `serialVersionUID`
    `private static javafx.scene.Group` | `subGroup`
    `private static javafx.scene.image.Image` | `up`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ThreeSixtyDegreeViewerPanel()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private static javafx.scene.Scene` | `createDefaultScene()`
    `static javafx.scene.Scene` | `createScene()`
    `static javafx.scene.Scene` | `createScene(java.awt.image.BufferedImage img0, java.awt.image.BufferedImage img1, java.awt.image.BufferedImage img2, java.awt.image.BufferedImage img3, java.awt.image.BufferedImage img4, java.awt.image.BufferedImage img5)`
    `CubemapBox` | `getCubemapBox()`
    `javafx.scene.Scene` | `getCubemapScene()`
    `javafx.scene.Scene` | `getDefaultScene()`
    `void` | `initialize()`

    - ### Methods inherited from class javafx.embed.swing.JFXPanel

      `addNotify, getInputMethodRequests, getPreferredSize, getScene, isOpaque, paintComponent, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeNotify, setOpaque, setScene`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getUIClassID, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, paramString, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update, updateUI`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAccessibleContext, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      See Also:
        Constant Field Values

    - #### cubemapScene

          private static javafx.scene.Scene cubemapScene

    - #### defaultScene

          private static javafx.scene.Scene defaultScene

    - #### root

          private static javafx.scene.Group root

    - #### subGroup

          private static javafx.scene.Group subGroup

    - #### cubemapBox

          private static CubemapBox cubemapBox

    - #### camera

          private static javafx.scene.PerspectiveCamera camera

    - #### cameraTransform

          private static CameraTransformer cameraTransform

    - #### mousePosX

          private static double mousePosX

    - #### mousePosY

          private static double mousePosY

    - #### mouseOldX

          private static double mouseOldX

    - #### mouseOldY

          private static double mouseOldY

    - #### mouseDeltaX

          private static double mouseDeltaX

    - #### mouseDeltaY

          private static double mouseDeltaY

    - #### cameraDistance

          private static double cameraDistance

    - #### front

          private static javafx.scene.image.Image front

    - #### right

          private static javafx.scene.image.Image right

    - #### back

          private static javafx.scene.image.Image back

    - #### left

          private static javafx.scene.image.Image left

    - #### up

          private static javafx.scene.image.Image up

    - #### down

          private static javafx.scene.image.Image down

  - ### Constructor Detail

    - #### ThreeSixtyDegreeViewerPanel

          public ThreeSixtyDegreeViewerPanel()

  - ### Method Detail

    - #### initialize

          public void initialize()

    - #### createScene

          public static javafx.scene.Scene createScene()

    - #### createDefaultScene

          private static javafx.scene.Scene createDefaultScene()

    - #### createScene

          public static javafx.scene.Scene createScene(java.awt.image.BufferedImage img0,
                                                       java.awt.image.BufferedImage img1,
                                                       java.awt.image.BufferedImage img2,
                                                       java.awt.image.BufferedImage img3,
                                                       java.awt.image.BufferedImage img4,
                                                       java.awt.image.BufferedImage img5)
                                                throws javafx.scene.transform.NonInvertibleTransformException

      Throws:
        `javafx.scene.transform.NonInvertibleTransformException`

    - #### getCubemapBox

          public CubemapBox getCubemapBox()

    - #### getDefaultScene

          public javafx.scene.Scene getDefaultScene()

    - #### getCubemapScene

          public javafx.scene.Scene getCubemapScene()

JOSM Plugins